#!/bin/bash
out_dir=plots
in_dir=output_test
mode=${1:-"x11"}
plot_id=1


#plot of delay experience of flow with ploss 10^-1
function plot_del_two()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\" 

						 " > tmp.txt
			options="-persist"
esac

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside right bottom vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \"delay_pkts \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 1 : 5000 ] noreverse nowriteback
set logscale y
set bmargin  3 
plot '$in_file_name' using 1:3 index 0 with lp title 			columnhead(1),      ''           using 1:3 index 1 with  	lp		title   columnhead(1),      ''           using 1:3 index 2 with 		lp	 title   columnhead(1),      ''           using 1:3 index 3 with 		lp	 title   columnhead(1)
    	" >> tmp.txt

    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}



#plot of delay experience of flow with ploss 10^-7
function plot_del_seven()
{
    in_file_name=$1
    out_file_name=$2
		title=$3
   
case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac 

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside right bottom vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \"delay_pkts \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 1 : 500 ] noreverse nowriteback
set logscale y
set bmargin  3 
plot '$in_file_name' using 1:4 index 0 with lp title 			columnhead(1),      ''           using 1:4 index 1 with  	lp		title   columnhead(1),      ''           using 1:4 index 2 with 		lp	 title   columnhead(1),      ''           using 1:4 index 3 with 		lp	 title   columnhead(1)
    	" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}


#plot of throughput
function plot_thr()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside right bottom vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 300 ] noreverse nowriteback
set ylabel \"Normalized throughput\" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
set yrange [ 0 : 1 ] noreverse nowriteback
set bmargin  3.1
plot '$in_file_name' using 1:2 index 0 with lp title 			columnhead(1),      ''           using 1:2 index 1 with  	lp		title   columnhead(1),      ''           using 1:2 index 2 with 		lp	 title   columnhead(1)    	" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}


#plot of delay experience for each flow (avarerage)
function plot_avg_del()
{
    in_file_name=$1
    out_file_name=$2
		title=$3
 
case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac   

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside right bottom vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \"delay_pkts \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 1 : 5000 ] noreverse nowriteback
set logscale y
set bmargin  3 
plot '$in_file_name' using 1:5 index 0 with lp title 			columnhead(1),      ''           using 1:5 index 1 with  	lp		title   columnhead(1),      ''           using 1:5 index 2 with 		lp	 title   columnhead(1),      ''           using 1:5 index 3 with 		lp	 title   columnhead(1)
    	" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}


#plot of normal fraction pkt_received / weight 
function plot_fair()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics nomxtics ytics nomytics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside right top vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 2
set xtics border in scale 0,0 mirror norotate  offset character  0, 0, 0 
set xtics  norangelimit
set ytics  (0,1000,10000)
#set ytics border in scale 0,0 mirror norotate  offset character 0, 0, 0 
set ztics border in scale 0,0 nomirror norotate  offset character 0, 0, 0
set cbtics border in scale 0,0 mirror norotate  offset character 0, 0, 0 
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" avg pkts processed / weight \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ -50 : 10000 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:6 index 0 with lines title 			columnhead(1),      ''           using 1:6 index 1 with lines 			title   columnhead(1),      ''           using 1:6 index 2 with 			lines title   columnhead(1)    	" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}



#plot of Worst case Fai Index 
function plot_wfi()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left top vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" MAC-SAL WFI [pkts] \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 0 : 50 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:7 index 0 with lp title 			columnhead(1),      ''           using 1:7 index 1 with  	lp		title   columnhead(1),      ''           using 1:7 index 2 with 		lp	 title   columnhead(1)

" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt
}


#plot of Worst Queueing Delay 
function plot_qdel()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left top vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" time [ms] \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 0 : 140 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:8 index 0 with lp title 			columnhead(1),      ''           using 1:8 index 1 with  	lp		title   columnhead(1),      ''           using 1:8 index 2 with 		lp	 title   columnhead(1),      ''           using 1:8 index 3 with 		lp	 title   columnhead(1)

" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}



#plot of Worst Queueing Delay  mac  10^-7
function plot_qdel_mac_seven()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left top vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" MAC-SAL delay [ms] \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 1 : 100 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:9 index 0 with lp title 			columnhead(1),      ''           using 1:9 index 1 with  	lp		title   columnhead(1),      ''           using 1:9 index 2 with 		lp	 title   columnhead(1),      ''           using 1:9 index 3 with 		lp	 title   columnhead(1)

" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}


#plot of Worst Queueing Delay  mac 10^-2
function plot_qdel_mac_two()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left top vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" time [ms] \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 1 : 180 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:10 index 0 with lp title 			columnhead(1),      ''           using 1:10 index 1 with  	lp		title   columnhead(1),      ''           using 1:10 index 2 with 		lp	 title   columnhead(1),      ''           using 1:10 index 3 with 		lp	 title   columnhead(1)

" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}



#plot of execution time of the tool
function plot_exec_time()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside right top vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \"Total execution time [ns] \"
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 0 : 500 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:11 index 0 with lp title 			columnhead(1),      ''           using 1:11 index 1 with  	lp		title   columnhead(1),      ''           using 1:11 index 2 with 		lp	 title   columnhead(1),      ''           using 1:11 index 3 with 		lp	 title   columnhead(1)
    	" >> tmp.txt

    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}


#constant
#plot_del_two $in_dir/test_constant.out $out_dir/del_pk_two_constant constant
#plot_del_seven $in_dir/test_constant.out $out_dir/del_pk_seven_constant constant
#plot_thr $in_dir/test_constant.out $out_dir/thr_constant constant
#plot_avg_del $in_dir/test_constant.out $out_dir/avg_del_pk_constant constant
#plot_fair $in_dir/test_constant.out $out_dir/fair_constant constant
#plot_wfi $in_dir/test_constant.out $out_dir/wfi_constant constant
#plot_qdel $in_dir/test_constant.out $out_dir/qdel_qos_time_constant constant
#plot_qdel_mac_seven $in_dir/test_constant.out $out_dir/qdel_mac_time_seven_constant constant
#plot_qdel_mac_two $in_dir/test_constant.out $out_dir/qdel_mac_time_two_constant constant
#plot_exec_time $in_dir/test_constant.out $out_dir/exec_time_constant constant

#linear
#plot_del_two $in_dir/test_linear.out $out_dir/del_pk_two_linear linear
#plot_del_seven $in_dir/test_linear.out $out_dir/del_pk_seven_linear linear
#plot_thr $in_dir/test_linear.out $out_dir/thr_linear linear
#plot_avg_del $in_dir/test_linear.out $out_dir/avg_del_pk_linear linear
#plot_fair $in_dir/test_linear.out $out_dir/fair_linear linear
#plot_wfi $in_dir/test_linear.out $out_dir/wfi_linear linear
#plot_qdel $in_dir/test_linear.out $out_dir/qdel_qos_time_linear linear
#plot_qdel_mac_seven $in_dir/test_linear.out $out_dir/qdel_mac_time_seven_linear linear
#plot_qdel_mac_two $in_dir/test_linear.out $out_dir/qdel_mac_time_two_linear linear
#plot_exec_time $in_dir/test_linear.out $out_dir/exec_time_linear linear


#exponential
#plot_del_two $in_dir/test_exponential.out $out_dir/del_pk_two_exponential exponential
#plot_del_seven $in_dir/test_exponential.out $out_dir/del_pk_seven_exponential exponential
#plot_thr $in_dir/test_exponential.out $out_dir/thr_exponential exponential
#plot_avg_del $in_dir/test_exponential.out $out_dir/avg_del_pk_exponential exponential
#plot_fair $in_dir/test_exponential.out $out_dir/fair_exponential exponential
#plot_wfi $in_dir/test_exponential.out $out_dir/wfi_exponential exponential
#plot_qdel $in_dir/test_exponential.out $out_dir/qdel_qos_time_exponential exponential
#plot_qdel_mac_seven $in_dir/test_exponential.out $out_dir/qdel_mac_time_seven_exponential exponential
#plot_qdel_mac_two $in_dir/test_exponential.out $out_dir/qdel_mac_time_two_exponential exponential
#plot_exec_time $in_dir/test_exponential.out $out_dir/exec_time_exponential exponential

#analogical
plot_del_two $in_dir/test_analogical.out $out_dir/del_pk_two_analogical analogical
plot_del_seven $in_dir/test_analogical.out $out_dir/del_pk_seven_analogical analogical
plot_thr $in_dir/test_analogical.out $out_dir/thr_analogical analogical
plot_avg_del $in_dir/test_analogical.out $out_dir/avg_del_pk_analogical analogical
#plot_fair $in_dir/test_analogical.out $out_dir/fair_analogical analogical
plot_wfi $in_dir/test_analogical.out $out_dir/wfi_analogical analogical
plot_qdel $in_dir/test_analogical.out $out_dir/qdel_qos_time_analogical analogical
plot_qdel_mac_seven $in_dir/test_analogical.out $out_dir/qdel_mac_time_seven_analogical analogical
plot_qdel_mac_two $in_dir/test_analogical.out $out_dir/qdel_mac_time_two_analogical analogical
plot_exec_time $in_dir/test_analogical.out $out_dir/exec_time_analogical analogical


#plot of Worst Queueing Delay 
function plot_total_qdel()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left center vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" Total delay [ms] \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 0 : 200 ] noreverse nowriteback
set bmargin  3
plot '$in_file_name' using 1:2 index 0 with lp title 			columnhead(1),      ''                            using 1:2 index 3 with 		lp	 title   columnhead(1), '' using 1:2 index 2 with 		lp	 title   columnhead(1)
" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}


#plot of Worst Case Fair Index 
function plot_total_wfi()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left center vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" b-WFI [pkts] \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 0 : 2 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:3 index 0 with lp title 			columnhead(1),      ''           using 1:3 index 2 with 		lp	 title   columnhead(1),      ''           using 1:3 index 3 with 		lp	 title   columnhead(1)
" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}


#plot of Worst Case Fair Index Interm 
function plot_total_wfi_interm()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left top vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" b-WFI [pkts]\" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 0 : 2 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:4 index 0 with lp title 			columnhead(1),      ''           using 1:4 index 2 with 		lp	 title   columnhead(1),      ''           using 1:4 index 3 with 		lp	 title   columnhead(1)
" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}


#plot of Time Worst Case Fair Index 
function plot_total_twfi()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left center vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" T-WFI [ms] \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 0 : 2 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:5 index 0 with lp title 			columnhead(1),      ''           using 1:5 index 2 with 		lp	 title   columnhead(1),      ''           using 1:5 index 3 with 		lp	 title   columnhead(1)
" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}



#plot of Time Worst Case Fair Index interm
function plot_total_twfi_interm()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics noztics nomztics nox2tics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left center vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \" T-WFI [ms] \" 
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
#set yrange [ 0 : 2 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:6 index 0 with lp title 			columnhead(1),      ''           using 1:6 index 2 with 		lp	 title   columnhead(1),      ''           using 1:6 index 3 with 		lp	 title   columnhead(1)
" >> tmp.txt


    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}






#plot of execution time of the tool
function plot_total_exec_time()
{
    in_file_name=$1
    out_file_name=$2
		title=$3

case $mode in 
    eps)
      printf "  set terminal post eps color font \"arial,20\" linewidth 2
			  				set output '$out_file_name.eps'
             " > tmp.txt
			options="-mono"
		  ;;
		png)
			printf "  set terminal png size 700, 350 font \"arial,14\"
                set output '$out_file_name.png'
						 " > tmp.txt
			options="-persist"
			;;
		*)
			printf "  set terminal x11 size 700, 350 font \"arial,14\"

						 " > tmp.txt
			options="-persist"
esac    

    printf "
set termoption enhanced
set encoding utf8
set style data linespoints
set grid nopolar
set grid noxtics   nomztics nomx2tics noy2tics nomy2tics nocbtics nomcbtics
set grid layerdefault   linetype 0 linewidth 1.000, linetype 0 linewidth 1.000
set key inside left  top  vertical Right noreverse enhanced autotitles nobox samplen 1
set pointsize 1.5
set xtics scale 1.0, 1.0
set xtics (1,40,80,120,160,200,240,280,320,360,400)
set mytics
set ytics scale 2.0, 1.0
#set xrange [ 1 : 400 ] noreverse nowriteback
set ylabel \"Total execution time [ns] \"
set xlabel \"MAC-SAL buffer size Q [pkts]\" 
set yrange [ 0 : 500 ] noreverse nowriteback
set bmargin  3 
plot '$in_file_name' using 1:7 index 0 with lp title 			columnhead(1),      ''           using 1:7 index 3 with  	lp		title   columnhead(1),      ''           using 1:7 index 2 with  	lp		title   columnhead(1)
    	" >> tmp.txt

    echo $plot_curves >> tmp.txt
    
    gnuplot $options < tmp.txt

}

#modif funz thr adattare x e agg un index ridimens


#constant
#plot_total_qdel $in_dir/total_test_constant.out $out_dir/total_qdel_constant constant
#plot_total_wfi $in_dir/total_test_constant.out $out_dir/total_wfi_constant constant
#plot_total_exec_time $in_dir/total_test_constant.out $out_dir/total_time_constant constant

#linear
#plot_total_qdel $in_dir/total_test_linear.out $out_dir/total_qdel_time_linear linear
#plot_total_wfi $in_dir/total_test_linear.out $out_dir/total_wfi_linear linear
#plot_total_twfi $in_dir/total_test_linear.out $out_dir/total_twfi_linear linear
#plot_total_twfi_interm $in_dir/total_test_linear.out $out_dir/total_twfi_interm_linear linear
#plot_total_exec_time $in_dir/total_test_linear.out $out_dir/total_exec_time_linear linear


#exponential
#plot_total_qdel $in_dir/total_test_exponential.out $out_dir/total_qdel_time_exponential exponential
#plot_total_wfi $in_dir/total_test_exponential.out $out_dir/total_wfi_exponential exponential
#plot_total_wfi_interm $in_dir/total_test_exponential.out $out_dir/total_wfi_interm_exponential exponential
#plot_total_twfi $in_dir/total_test_exponential.out $out_dir/total_twfi_exponential exponential
#plot_total_twfi_interm $in_dir/total_test_exponential.out $out_dir/total_twfi_interm_exponential exponential
#plot_total_exec_time $in_dir/total_test_exponential.out $out_dir/total_exec_time_exponential exponential

#analogical
plot_total_qdel $in_dir/total_test_analogical.out $out_dir/total_qdel_time_analogical analogical
plot_total_wfi $in_dir/total_test_analogical.out $out_dir/total_wfi_analogical analogical
plot_total_wfi_interm $in_dir/total_test_analogical.out $out_dir/total_wfi_interm_analogical analogical
plot_total_twfi $in_dir/total_test_analogical.out $out_dir/total_twfi_analogical analogical
plot_total_twfi_interm $in_dir/total_test_analogical.out $out_dir/total_twfi_interm_analogical analogical
plot_total_exec_time $in_dir/total_test_analogical.out $out_dir/total_exec_time_analogical analogical


rm tmp.txt


