#!/bin/bash

# Create one stat file for each value in BURSTS, containing the
# average execution time for each scheduler in SCHEDS and for each
# flowset in FLOWSETS
SCHED="qfq+ rr wf2qp fifo kps"
SCHEDSTAT=(QFQ+ DRR WF^\{2\}Q+ FIFO KPS)
FLOWS=(1 5 10 50 100 500 1000 5000 10000 30000)
FLOWSETS="1::1 1::5 1::10 1::50 1::100 1::500 1::1000 1::5000 1::10000 1::30000"
CMD=./test
FIELDNR=8
NUM_ITER=5
NUM_EVENTS=10M

qmin=4n
qmax=30n
BURST=1
QSING=0

  
     counter_sched=-1
     for sched in $SCHED
     do
     counter_flow=0
     counter_sched=$(($counter_sched + 1))
     echo >> test_time_all.out #white space
     echo >> test_time_all.out #white space
     echo ${SCHEDSTAT[$counter_sched]} >> test_time_all.out
       for flowsets in $FLOWSETS
       do
       time=0;
          for ((i = 0 ; $i < $NUM_ITER; i++))
          do
          echo $CMD -n $NUM_EVENTS -qmin $qmin -qmax $qmax -flowsets \
                $flowsets -stats 4 \
                -mode single -alg $sched 
          STATS=$($CMD -n $NUM_EVENTS -qmin $qmin -qmax $qmax -flowsets \
                $flowsets -stats 4 \
                -mode single -alg $sched )
          array=($STATS)
          #echo time: ${array[5]}
          time=$(echo $time+${array[5]} | bc)
          done
       time=$(echo $time/$NUM_ITER | bc -l)
       echo ${FLOWS[$counter_flow]} $time >> test_time_all.out
       counter_flow=$(($counter_flow + 1))
       done
     done

mv *.out ../graphs/output_test_tempest/

  sleep 1