#!/bin/bash

# Create one stat file for each value in BURSTS, containing the
# average execution time for each scheduler in SCHEDS and for each
# flowset in FLOWSETS
SCHED="qfq+ rr wf2qp fifo kps"
SCHEDSTAT=(QFQ+ DRR WF^\{2\}Q+ FIFO KPS)
DELTA=(1 10 100 1000)
FLOWSETS="1::5000,2::5000 1::7000,11::3000 1::8000,10::1000,101::1000 1::9999,1001::1"
CMD=./test
FIELDNR=8
NUM_ITER=1
NUM_EVENTS=5M

qmin=10n
qmax=20n
BURST=1
QSING=0

  
     counter_sched=-1
     for sched in $SCHED
     do
     counter_flow=0
     counter_sched=$(($counter_sched + 1))
     echo >> test_twfi_all.out #white space
     echo >> test_twfi_all.out #white space
     echo ${SCHEDSTAT[$counter_sched]} >> test_twfi_all.out
       for flowsets in $FLOWSETS
       do
       twfi=0;
          for ((i = 0 ; $i < $NUM_ITER; i++))
          do
          echo $CMD -n $NUM_EVENTS -qmin $qmin -qmax $qmax -flowsets \
                $flowsets -stats 4 \
                -mode single -alg $sched 
          STATS=$($CMD -n $NUM_EVENTS -qmin $qmin -qmax $qmax -flowsets \
                $flowsets -stats 4 \
                -mode single -alg $sched )
          array=($STATS)
          #echo twfi: ${array[3]}
          twfi=$(echo $twfi+${array[3]} | bc)
          done
       twfi=$(echo $twfi/$NUM_ITER | bc -l)
       echo ${DELTA[$counter_flow]} $twfi >> test_twfi_all.out
       counter_flow=$(($counter_flow + 1))
       done
     done

mv *.out ../graphs/output_test_tempest/

  sleep 1